--[[
Interface: 1.6.0.0 b9173

Copyright (C) GtX (Andy), 2019

Author: GtX | Andy
Date: 15.12.2019
Version: 1.0.0.0

Contact:
https://forum.giants-software.com
https://github.com/GtX-Andy

Important:
Free for use in other mods - no permission needed.
No changes are to be made to this script without permission from GtX | Andy

Frei verwendbar - keine erlaubnis nötig
An diesem Skript dürfen ohne Genehmigung von GtX | Andy keine Änderungen vorgenommen werden
]]


local targetMarker
local targetMarkerFilename = "data/shared/mapTargetMarker.i3d"

local modName = g_currentModName
local modDirectory = g_currentModDirectory

local function removeTargetMarker()
    if BunkerSiloDisplay ~= nil then
        BunkerSiloDisplay.TARGET_MARKER = nil
    end

    if targetMarker ~= nil then
        delete(targetMarker)
        targetMarker = nil
    end
end

local function init()
    local placeablePath = Utils.getFilename("scripts/BunkerSiloDisplay.lua", modDirectory)

    if fileExists(placeablePath) then
        local eventPath = Utils.getFilename("scripts/events/BunkerSiloDisplayConfigEvent.lua", modDirectory)

        if fileExists(eventPath) then
            source(eventPath)
            g_placeableTypeManager:addPlaceableType("bunkerSiloDisplay", "BunkerSiloDisplay", placeablePath)

            if BunkerSiloDisplay ~= nil and fileExists(targetMarkerFilename) then
                local i3dNode = loadI3DFile(targetMarkerFilename, false, false, false)

                if i3dNode ~= 0 then
                    if getNumOfChildren(i3dNode) > 0 then
                        local child = getChildAt(i3dNode, 0)

                        link(getRootNode(), child)
                        setVisibility(child, false)

                        targetMarker = child
                        BunkerSiloDisplay.TARGET_MARKER = targetMarker

                        FSBaseMission.delete = Utils.appendedFunction(FSBaseMission.delete, removeTargetMarker)
                    end

                    delete(i3dNode)
                end
            else
                print(string.format("  Error: [%s]  Target marker file %s failed to load or could not be found!", modName, targetMarkerFilename))
            end
        else
            print(string.format("  Error: [%s]  Required file %s could not be found!", modName, eventPath))
        end
    else
        print(string.format("  Error: [%s]  Required file %s could not be found!", modName, placeablePath))
    end
end

init()
