--[[
Interface: 1.6.0.0 b9173

Copyright (C) GtX (Andy), 2019

Author: GtX | Andy
Date: 15.12.2019
Version: 1.0.0.0

Contact:
https://forum.giants-software.com
https://github.com/GtX-Andy

Important:
Free for use in other mods - no permission needed.
No changes are to be made to this script without permission from GtX | Andy

Frei verwendbar - keine erlaubnis nötig
An diesem Skript dürfen ohne Genehmigung von GtX | Andy keine Änderungen vorgenommen werden
]]

BunkerSiloDisplayConfigEvent = {}

BunkerSiloDisplayConfigEvent_mt = Class(BunkerSiloDisplayConfigEvent, Event)
InitEventClass(BunkerSiloDisplayConfigEvent, "BunkerSiloDisplayConfigEvent")

function BunkerSiloDisplayConfigEvent:emptyNew()
    local self = Event:new(BunkerSiloDisplayConfigEvent_mt)
    return self
end

function BunkerSiloDisplayConfigEvent:new(bunkerSiloDisplay, configId)
    local self = BunkerSiloDisplayConfigEvent:emptyNew()

    self.bunkerSiloDisplay = bunkerSiloDisplay
    self.configId = configId

    return self
end

function BunkerSiloDisplayConfigEvent:readStream(streamId, connection)
    self.bunkerSiloDisplay = NetworkUtil.readNodeObject(streamId)
    self.configId = streamReadUInt8(streamId)

    self:run(connection)
end

function BunkerSiloDisplayConfigEvent:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.bunkerSiloDisplay)
    streamWriteUInt8(streamId, self.configId)
end

function BunkerSiloDisplayConfigEvent:run(connection)
    if self.bunkerSiloDisplay ~= nil and self.configId ~= nil then
        self.bunkerSiloDisplay:setActiveDisplayConfiguration(self.configId, true)

        if not connection:getIsServer() then
            g_server:broadcastEvent(self, false, connection, self.bunkerSiloDisplay)
        end
    end
end

function BunkerSiloDisplayConfigEvent.sendEvent(bunkerSiloDisplay, configId, noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(BunkerSiloDisplayConfigEvent:new(bunkerSiloDisplay, configId), nil, nil, bunkerSiloDisplay)
        else
            g_client:getServerConnection():sendEvent(BunkerSiloDisplayConfigEvent:new(bunkerSiloDisplay, configId))
        end
    end
end
